//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
const MAXBUFLINES=4096;
HANDLE hComm=INVALID_HANDLE_VALUE;
const DWORD InBufSize=256, OutBufSize=256;
BYTE InBuf[InBufSize], OutBuf[OutBufSize];
DCB Dcb;
char PortName[16]="COM2";
DWORD Baudrate=9600;
BYTE Parity=NOPARITY;
BYTE Stopbits=ONESTOPBIT;
COMMTIMEOUTS CommTimeouts;
DWORD CommErrors;
bool RxBusy;
long BufLines;
FILE *rcv;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  BufLines=0L;
  RxBusy=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  char InBufString[256];
  COMSTAT ComStat;
  DWORD BytesToRead;
  DWORD BytesRead;
  unsigned int i;

  if(!RxBusy)
  {
    RxBusy=true;
    ClearCommError(hComm,&CommErrors,&ComStat);
    if(ComStat.cbInQue>0)
    {
      if(ComStat.cbInQue<256) BytesToRead=ComStat.cbInQue;
      else BytesToRead=256;
      ReadFile(hComm,InBuf,BytesToRead,&BytesRead,NULL);
      if(BytesRead>0)
        for(i=0;i<BytesRead;i++)
        {
          sprintf(InBufString,"%02X",InBuf[i]);
          rcv=fopen("received.txt","at");
          fprintf(rcv,"%02X\n",InBuf[i]);
          fclose(rcv);
          Memo1->Lines->Add(AnsiString(InBufString));
          BufLines++;
          if(BufLines>MAXBUFLINES) Button3->Click();
          Edit1->Text=AnsiString((int)BufLines);
          Edit1->Refresh();
        }
    }
    RxBusy=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  hComm=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL,0);
  if(hComm==INVALID_HANDLE_VALUE)
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  if(!SetupComm(hComm,InBufSize,OutBufSize))
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  if(!GetCommState(hComm,&Dcb))
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  Dcb.BaudRate=Baudrate;
  Dcb.Parity=Parity;
  Dcb.StopBits=Stopbits;
  if(!SetCommState(hComm,&Dcb))
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  if(!GetCommTimeouts(hComm,&CommTimeouts))
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  CommTimeouts.ReadIntervalTimeout = 0;
  CommTimeouts.ReadTotalTimeoutMultiplier = 0;
  CommTimeouts.ReadTotalTimeoutConstant = 0;
  CommTimeouts.WriteTotalTimeoutMultiplier = 0;
  CommTimeouts.WriteTotalTimeoutConstant = 0;
  if(!SetCommTimeouts(hComm,&CommTimeouts))
  {
    ShowMessage("  .");
    Application->Terminate();
  }
  Timer1->Enabled=true;
  Button1->Enabled=false;
  Button2->Enabled=true;
  Button4->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Memo1->Clear();
  BufLines=0L;
  Edit1->Text=AnsiString((int)BufLines);
  Edit1->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Timer1->Enabled=false;
  CloseHandle(hComm);
  hComm=INVALID_HANDLE_VALUE;
  Button1->Enabled=true;
  Button2->Enabled=false;
  Button4->Enabled=false;
  rcv=fopen("received.txt","at");
  fprintf(rcv,"\n");
  fclose(rcv);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  Button2->Click();
  strcpy(PortName,ComboBox1->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
  Button2->Click();
  Baudrate=ComboBox2->Text.ToInt();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Change(TObject *Sender)
{
  Button2->Click();
  if(ComboBox3->Text=="NO") Parity=NOPARITY;
  if(ComboBox3->Text=="EVEN") Parity=EVENPARITY;
  if(ComboBox3->Text=="MARK") Parity=MARKPARITY;
  if(ComboBox3->Text=="ODD") Parity=ODDPARITY;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox4Change(TObject *Sender)
{
  Button2->Click();
  if(ComboBox4->Text=="1") Stopbits=ONESTOPBIT;
  if(ComboBox4->Text=="1.5") Stopbits=ONE5STOPBITS;
  if(ComboBox4->Text=="2") Stopbits=TWOSTOPBITS;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
//  int ss;
  char codestr[16];
//  int code;
  int i;
  int OutBytes;
  unsigned long TXed=0;

  OutBytes=Memo2->Lines->Count;
  if(Timer1->Enabled)
  {
    for(i=0;i<OutBytes;i++)
    {
      strcpy(codestr,Memo2->Lines->Strings[i].c_str());
      sscanf(codestr,"%x",OutBuf+i);
    }
    WriteFile(hComm,OutBuf,OutBytes,&TXed,NULL);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
  Form1->Close();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Form2->ShowModal();	
}
//---------------------------------------------------------------------------
